Redmine - Defect #7114

New gantt doesn't display some projects
2010-12-15 22:45 - Jean-Baptiste Barth

Status: Closed Start date: 2010-12-15
Priority: Low Due date:

Assignee: Jean-Baptiste Barth % Done: 0%
Category: Gantt Estimated time: 0.00 hour
Target version: 1.2.0

Resolution: Fixed Affected version:

Description

With new gantt charts, subprojects for which parent project doesn't have issue_tracking enabled are not shown.

Explicit use case: | defined some root projects where | only enable gantt, calendar and news systems, and subprojects which map to
real-world projects so they have issues, versions, documents, etc.

| have a working patch for that, but it's pretty inefficient:

e either you display all projects (not desired behaviour | suppose?)
¢ either you try to find if a project have descendants with issue_tracking enabled (respecting visibility...)

I'd welcome any suggestion to define what should be the desired behaviour and what are the potential extreme cases we don't want
to handle.

Related issues:
Related to Redmine - Patch #7456: Gantt filters New 2011-01-26

History

#1 - 2010-12-16 07:27 - Mischa The Evil

Good catch! I'd vote +1 for your second solution, though it shouldn't introduce (more?) performance issues within such an implementation.

#2 - 2010-12-16 11:16 - Jean-Philippe Lang

- File show_projects_having _a_descendant_with_issue_tracking.patch added

The attached patch should fix it with option 2.

#3 - 2010-12-16 22:12 - Jean-Baptiste Barth

Still hard to use on a large project base : 100+ projects => "Completed in 24617ms", VS 1.6s for the test database. | had nearly the same results with
my patch but it was less clean (I imagine parsing .descendants for each project costs a lot). I'll try to see if | can improve it.

#4 - 2010-12-17 07:05 - Jean-Baptiste Barth

OK, nothing to do with searching for .descendants in each project. | turned on development mode, | end up with some 922 queries to the database,
maybe a bit too much ;) To be continued

#5 - 2010-12-17 09:21 - Jean-Philippe Lang

And I've already made a few optimizations on the initial implementation. It's still very slow and | think we'll have to make some compromises, like
removing project/version completion calculation which generates a bunch of queries. Project completion is not calculated properly BTW.

#6 - 2011-03-10 19:16 - Jean-Philippe Lang
- Status changed from New to Closed
- Target version set to 1.2.0

- Resolution set to Fixed

Fixed in r5077.
https://www.redmine.org/projects/redmine/repository/svn/revisions/5077

show_projects_having_a_descendant_with_issue_tracking.patch 8.1 KB 2010-12-16 Jean-Philippe Lang
